var browser = {};
        var ua = navigator.userAgent.toLowerCase();

        browser.msie = (/msie ([\d.]+)/).test(ua);
        browser.firefox = (/firefox\/([\d.]+)/).test(ua);
        browser.chrome = (/chrome\/([\d.]+)/).test(ua);

        function SetNodeStyle(doc, node, name, value)
        {
            if (node.innerHTML == undefined)
            {
                return node;
            }
            else
            {
                node.style[name] = value;

                for (var i = 0; i < node.childNodes.length; i++)
                {
                    var cn = node.childNodes[i];
                    if (node.innerHTML != undefined)
                    {
                        SetNodeStyle(doc, cn, name, value);
                    }
                }

                return node;
            }
        }

        function SetStyle(doc, html, name, value)
        {
            var dom = doc.createElement("DIV");
            dom.innerHTML = html;

            for (var i = 0; i < dom.childNodes.length; i++)
            {
                var node = dom.childNodes[i];

                if (node.innerHTML == undefined)
                {
                    var span = doc.createElement("SPAN");
                    span.style[name] = value;
                    if (node.nodeValue != undefined) span.innerHTML = node.nodeValue.replace(/\</ig, function() { return "&lt;"; });
                    else if (node.textContent != undefined) span.innetHTML = node.textContent.replace(/\</ig, function() { return "&lt;"; });
                    dom.replaceChild(span, node);
                }
                else
                {
                    SetNodeStyle(doc, node, name, value);
                }
            }

            return dom.innerHTML;
        }

		//
        function GetInnerHTML(nodes)
        {
            var builder = [];
            for (var i = 0; i < nodes.length; i++)
            {
                if (nodes[i].innerHTML != undefined)
                {
                    builder.push(nodes[i].innerHTML);
                }
                else
                {
                    if (nodes[i].textContent) builder.push(nodes[i].textContent.replace(/\</ig, function() { return "&lt;"; }));
                    else if (nodes[i].nodeValue) builder.push(nodes[i].nodeValue.replace(/\</ig, function() { return "&lt;"; }));
                }
            }
            return builder.join("");
        }

        //odç󴫮ĪG
		function SelectionRange(doc, range)
        {
            this.GetSelectedHtml = function()
            {
                if (range == null) return "";
                
                if (browser.msie)
                {
                    if (range.htmlText != undefined) return range.htmlText;
                    else return "";
                }
                else if (browser.firefox || browser.chrome)
                {
                    return GetInnerHTML(range.cloneContents().childNodes);
                }
                else
                {
                    return "";
                }
            }

            //󴫿dĪG
			this.Replace = function(html)
            {
                if (range != null)
                {
                    if (browser.msie)
                    {
                        if (range.pasteHTML != undefined)
                        {
                            range.select();
                            range.pasteHTML(html);
                            return true;
                        }
                    }
                    else if (browser.firefox || browser.chrome)
                    {
                        if (range.deleteContents != undefined && range.insertNode != undefined)
                        {
                            var temp = doc.createElement("DIV");
                            temp.innerHTML = html;

                            var elems = [];
                            for (var i = 0; i < temp.childNodes.length; i++)
                            {
                                elems.push(temp.childNodes[i]);
                            }

                            range.deleteContents();

                            for (var i in elems)
                            {
                                temp.removeChild(elems[i]);
                                range.insertNode(elems[i]);
                            }
                            return true;
                        }
                    }
                }
                return false;
            }
        }

        //o(ϥ)d
		function GetSelectionRange(win)
        {
            var range = null;

            if (browser.msie)
            {
                range = win.document.selection.createRange();
                if (range.parentElement().document != win.document)
                {
                    range = null;
                }
            }
            else if (browser.firefox || browser.chrome)
            {
                var sel = win.getSelection();
                if (sel.rangeCount > 0) range = sel.getRangeAt(0); else range = null;
            }

            return new SelectionRange(win.document, range);
        }
		
        //s边]w
		function edueditor(container,formLoc, width, height)
        {
			//w`IAó]w`Iʧ@
			parentElement = container.parentNode;
			//parentElement = formLoc;
			//alert(formLoc.id+","+container.id);
			formLoc.onsubmit = function(){
				change();
			}
			//åؼФr
			container.style.display = "none";
			
			//إhtmls边ó]wݩ
			var newTA_Element = new createPanel("newTA_Element",width,height,"div",1,"#ffffff");
			newTA_Element.style.display = "block";
			newTA_Element.style.borderWidth = "1px";
			newTA_Element.style.borderStyle = "inset";
			
			//Jhtmls边ó]we
			parentElement.insertBefore(newTA_Element,container);
			newTA_Element.innerHTML =
			'<div style="margin: 0px; padding: 0px; background-color: #ccedfc;"><table width="100%" border="1" align="center" cellpadding="5" cellspacing="0" bordercolor="#999999">'+
				'<tr><td width="13%" valign="top" bordercolor="#F2F2F2" bgcolor="#F2F2F2"><span class="style1">٭</span><br>'+
				'<img src="../../edueditor/image/b01.jpg" alt="_" name="undo" id="undo" width="26" height="27" border="0">'+
				'<img src="../../edueditor/image/b02.jpg" alt="_" name="redo" id="redo" width="28" height="27" border="0"><br></td>'+
				'<td width="34%" valign="top" bordercolor="#F2F2F2" bgcolor="#F2F2F2"><span class="style1">rPjp</span><br>'+
				'<label><select name="fontStyle" id="fontStyle">'+
				'<option value="sө">sө</option><option value="з">з</option>'+
				'<option value="Arial">Arial</option><option value="Arial Black">Arial Black</option>'+
				'</select></label>'+
				'<label><select name="fontSize" id="fontSize">'+
				'<option value="8px">8</option><option value="10px">10</option>'+
				'<option value="12px">12</option><option value="14px">14</option></select></label><br></td>'+
				'<td width="34%" valign="top" bordercolor="#F2F2F2" bgcolor="#F2F2F2"><span class="style1">r˦</span><br>'+
				'<img src="../../edueditor/image/b03.jpg" alt="rC" name="wordColor" id="wordColor" width="27" height="27" border="0">'+
				'<img src="../../edueditor/image/b04.jpg" alt="IC" name="wordBackColor" id="wordBackColor" width="27" height="27" border="0">'+
				'<img src="../../edueditor/image/b05.jpg" alt="" name="bold" id="bold" width="26" height="27" border="0">'+
				'<img src="../../edueditor/image/b06.jpg" alt="" name="italic" id="italic" width="27" height="27" border="0">'+
				'<img src="../../edueditor/image/b07.jpg" alt="u" name="underline" id="underline" width="26" height="27" border="0">'+
				'<img src="../../edueditor/image/b08.jpg" alt="Ru" name="strikeThrough" id="strikeThrough" width="27" height="27" border="0">'+
				/*'<td width="19%" valign="top" bordercolor="#F2F2F2" bgcolor="#F2F2F2"><span class="style1">J</span><br>'+
				'<img src="../../edueditor/image/b09.jpg" alt="ϧΪ" name="expression" id="expression" width="28" height="27" border="0">'+
				'<img src="../../edueditor/image/b10.jpg" alt="r" name="wordExpression" id="wordExpression" width="26" height="27" border="0">'+
				'<img src="../../edueditor/image/b11.jpg" alt="SŸ" name="symbol" id="symbol" width="26" height="27" border="0">*/
				'</td></tr></table></div>'+
			'<iframe frameborder="1" style="padding: 0px;"></iframe>'+
			'<div style="position:fixed; display:block; left:8px; top:60px; background-color:#CECDFF; z-index:1; border:1px solid;">ӳﶵ</div>';

			//wquCνs
            var toolbar = newTA_Element.childNodes[0];
            var editor = newTA_Element.childNodes[1];
			var flotToolbar = newTA_Element.childNodes[2];
			
			
            var editorDoc = editor.contentWindow.document;
            var editorWindow = editor.contentWindow;
			
			//sܧPܰʭrؤe
			function change(){
				i_value = editorDoc.body.innerHTML;
				/*var myregex = new RegExp("\\"+"\"");
				while(myregex.test(i_value)){
					i_value=i_value.replace(myregex,"\\\\\"");
				}*/
				/*if(myregex.test(i_value)){
					alert(""+myregex);
				}*/
				//i_value.replace('\\'+'\"','');
				container.value = i_value;
				//alert(container.value+","+parentElement.id);
			}
			
			//wquCνsϪe
            toolbar.style.width = width + 'px';
            toolbar.style.height = '80px';
            editor.style.width = width + 'px';
            editor.style.height = (height - 90) + 'px';
			flotToolbar.style.width = width +'px';

            //]wsϥis
			if (browser.firefox)
            {
                editor.onload = function()
                {
                    editorDoc.designMode = "on";
                }
            }
            else
            {
                editorDoc.designMode = "on";
            }

            //]wsϰ򥻤e
			editorDoc.open();
            editorDoc.write("<html><head></head><body style='margin:0px; padding: 0px;'></body></html>");
            editorDoc.close();
			
			//]wu@ϰʧ@
            //r]w
			document.getElementById("bold").onclick = function()
            {
                editorDoc.execCommand("Bold", false, null);
           }
			
			//r]wCu
            document.getElementById("underline").onclick = function()
            {
                editorDoc.execCommand("Underline", false, null);
            }

			//r]wo
            document.getElementById("italic").onclick = function()
            {
                editorDoc.execCommand("Italic", false, null);
            }
			
			//r]wRu
			document.getElementById("strikeThrough").onclick = function(){
				editorDoc.execCommand("strikeThrough", false, null);
			}

			//r]wjp
            document.getElementById("fontSize").onchange = function()
            {
                var range = GetSelectionRange(editorWindow);
                var html = SetStyle(editorDoc, range.GetSelectedHtml(), "fontSize", document.getElementById("fontSize").value);
                range.Replace(html);
            }
			
			//r]wr
            document.getElementById("fontStyle").onchange = function()
            {
                var range = GetSelectionRange(editorWindow);
                var html = SetStyle(editorDoc, range.GetSelectedHtml(), "fontFamily", document.getElementById("fontStyle").value);
                range.Replace(html);
            }
			
			//_P
			document.getElementById("undo").onclick = function(){
				editorDoc.execCommand("Undo", false, null);
			}
			document.getElementById("redo").onclick = function(){
				editorDoc.execCommand("Redo", false, null);
			}
			
			var color= new Array("#000000","#999999","#CCCCCC","#FFFFFF","#EE1D24","#FF9900","#FFF100","#00AEEF","#2F3192","#ED008C");
			
			//קrCP
			document.getElementById("wordColor").onclick = function(){
				list(flotToolbar,color);
				var range = GetSelectionRange(editorWindow);
				flotToolbar.childNodes[0].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[0]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[1].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[1]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[2].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[2]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[3].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[3]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[4].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[4]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[5].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[5]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[6].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[6]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[7].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[7]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[8].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[8]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[9].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "color", color[9]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
			}
			document.getElementById("wordBackColor").onclick = function(){
				list(flotToolbar,color);
				var range = GetSelectionRange(editorWindow);
				flotToolbar.childNodes[0].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[0]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[1].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[1]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[2].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[2]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[3].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[3]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[4].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[4]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[5].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[5]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[6].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[6]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[7].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[7]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[8].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[8]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
				flotToolbar.childNodes[9].onclick = function(){
					var html = SetStyle(editorDoc, range.GetSelectedHtml(), "backgroundColor", color[9]);
					range.Replace(html);
					dis_removePanel(flotToolbar);
				}
			}
			
			//JϤ
            /*toolbar.childNodes[0].onclick = function()
            {
                var src = prompt("пJϤ}:", "");
                if (src != null)
                {
                    var range = GetSelectionRange(editorWindow);
                    range.Replace("<img src='" + src + "'></img>");
                }
            }*/
			/*
			//J
			document.getElementById("expression").onclick = function(){
				var insert_Expression = new createPanel("insert_Expression",width,20);
				showPanel(insert_Expression, this, editor, newTA_Element);
			}
			//Jr
			document.getElementById("wordExpression").onclick = function(){
				var insert_WordExpression = new createPanel("insert_WordExpression",width,20);
				showPanel(insert_WordExpression, this, editor, newTA_Element);
			}
			
			//JŸ
			document.getElementById("symbol").onclick = function(){
				var insert_Symbol = new createPanel("insert_Symbol",width,20);
				showPanel(insert_Symbol, this, editor, newTA_Element);
			}
			*/
        } 
		
		function list(tar,arr){
			tar.style.display = "block";
			var html;
			for(var i=0;i < arr.length; i++){
				if( i != 0){
					html += "<span style='width:1px ; height:1px ; color:"+arr[i]+"; cursor:pointer; -moz-user-select:-moz-none; -webkit-user-select:none;' id='"+arr[i]+"' name='"+arr[i]+"'></span>";
				}else if(i == 0){
					html = "<span style='width:1px ; height:1px ; color:"+arr[i]+"; cursor:pointer; -moz-user-select:-moz-none; -webkit-user-select:none;' id='"+arr[i]+"' name='"+arr[i]+"'></span>";
				}
			}
			html += "<div id='close' name='close' style='float:right; cursor:pointer; -moz-user-select:-moz-none; -webkit-user-select:none;'>X</div>";
			tar.innerHTML = html;
			var close = document.getElementById("close");
			close.onclick = function(){
				dis_removePanel(close.parentNode);
			}
		}
		
		
		
		function dis_removePanel(tar){
			tar.innerHTML="ӳﶵ";
			/*tar.style.display = "none";
			tar.parentNode.removeChild(tar);*/
		}
		
		/*function showPanel( obj, tar, loc_tar, par_tar ){
			var left = 10;
			var top = 60;
			par_tar.appendChild(obj,loc_tar);
			obj.style.position = "fixed";
			obj.style.display = "block";*/
			/*left = event.clientX;
			top = event.clientY;*/
			/*obj.style.left = left;
			obj.style.top = top;
			obj.style.zindex = 1;
		}*/
		
		function createPanel(panelName,width,height,type,border,bkcolor){
			type = type || "div";
			width = width || "90";
			height = height || "65";
			border = border || "1";
			bkcolor = bkcolor || "#CECDFF";
			var panelName_name = panelName;
			var panelName = document.createElement(type);
			panelName.name = panelName_name;
			panelName.id = panelName_name;
			panelName.style.borderStyle = "solid";
			panelName.style.borderWidth = border + 'px';
			panelName.style.width = width + 'px';
			panelName.style.height = height + 'px';
			panelName.style.backgroundColor = bkcolor;
			panelName.style.display = "none";
			return panelName;
		}