-- 
-- 資料表格式： `eduweb_download`
-- 

CREATE TABLE `eduweb_download` (
  `id` int(11) NOT NULL auto_increment,
  `download_name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `download_txt` mediumtext collate utf8_unicode_ci NOT NULL,
  `folder_txt` mediumtext collate utf8_unicode_ci NOT NULL,
  `download_files` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `download_http` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `download_type` varchar(2) collate utf8_unicode_ci NOT NULL default '',
  `download_dates` datetime NOT NULL default '0000-00-00 00:00:00',
  `isdir` int(11) NOT NULL default '0',
  `isdir_name` varchar(150) collate utf8_unicode_ci NOT NULL default '',
  `download_list` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `user_ids` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `modules_ids` int(11) NOT NULL default '0',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`),
  KEY `modules_ids` (`modules_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

-- 
-- 資料表格式： `eduweb_download_cf`
-- 

CREATE TABLE `eduweb_download_cf` (
  `id` int(11) NOT NULL auto_increment,
  `files_class` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `files_size` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `dates` datetime NOT NULL default '0000-00-00 00:00:00',
  `desc_set` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `user_ids` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_ids` int(11) NOT NULL default '0',
  KEY `id` (`id`),
  KEY `modules_ids` (`modules_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;