-- 
-- ƪ榡G `eduwebsystem_administrator`
-- 

CREATE TABLE `eduwebsystem_administrator` (
  `id` int(11) NOT NULL auto_increment,
  `ad_home_set` int(11) NOT NULL default '1',
  `ad_home_set2` int(11) NOT NULL default '1',
  `ad_sort` int(11) NOT NULL default '0',
  `ad_sort2` int(11) NOT NULL default '0',
  `ad_sort3` int(11) NOT NULL default '0',
  `ad_groups` varchar(20) collate utf8_unicode_ci NOT NULL default 'other',
  `ad_groups_order` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `ad_transfer_set` int(11) NOT NULL default '1',
  `ad_transfer` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `http_user` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `http_pws` varchar(80) collate utf8_unicode_ci NOT NULL default '',
  `add_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `http_class` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `http_student_id` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `http_noum` int(11) NOT NULL default '0',
  `http_duty` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `http_birthday1` varchar(5) collate utf8_unicode_ci NOT NULL default '',
  `http_birthday2` varchar(5) collate utf8_unicode_ci NOT NULL default '',
  `http_links` varchar(200) collate utf8_unicode_ci NOT NULL default '',
  `http_user_intr` mediumtext collate utf8_unicode_ci NOT NULL,
  `http_images` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `http_title` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `http_sex` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `http_no` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `http_name_open` varchar(11) collate utf8_unicode_ci NOT NULL default '0',
  `http_name` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `ranks` varchar(5) collate utf8_unicode_ci NOT NULL default '1',
  `tels` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `tels1` varchar(18) collate utf8_unicode_ci NOT NULL default '',
  `tels2` varchar(18) collate utf8_unicode_ci NOT NULL default '',
  `class_https` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `class_nu` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `class_name` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `text_users` mediumtext collate utf8_unicode_ci NOT NULL,
  `dates` date NOT NULL default '0000-00-00',
  `email` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `note1` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `note2` int(11) NOT NULL default '0',
  `note3` mediumtext collate utf8_unicode_ci NOT NULL,
  `capacity_ceiling` bigint(20) NOT NULL default '0',
  `capacity_floor` bigint(20) NOT NULL default '0',
  `capacity_floor_unit` varchar(3) collate utf8_unicode_ci NOT NULL default '',
  `home_hots` int(11) NOT NULL default '0',
  `admin_ranks` varchar(5) collate utf8_unicode_ci NOT NULL default '',
  `admin_grade` int(11) NOT NULL default '0',
  `http_in` varchar(10) collate utf8_unicode_ci NOT NULL default '',
  `modules` mediumtext collate utf8_unicode_ci NOT NULL,
  KEY `id` (`id`),
  KEY `http_no` (`http_no`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
-- 
-- CXHUƮwƾڡG `eduwebsystem_administrator`
-- 

INSERT INTO `eduwebsystem_administrator` (`id`, `ad_home_set`, `ad_home_set2`, `ad_sort`, `ad_sort2`, `ad_sort3`, `ad_groups`, `ad_groups_order`, `ad_transfer_set`, `ad_transfer`, `http_user`, `http_pws`, `add_date`, `http_class`, `http_student_id`, `http_noum`, `http_duty`, `http_birthday1`, `http_birthday2`, `http_links`, `http_user_intr`, `http_images`, `http_title`, `http_sex`, `http_no`, `http_name_open`, `http_name`, `ranks`, `tels`, `tels1`, `tels2`, `class_https`, `class_nu`, `class_name`, `text_users`, `dates`, `email`, `note1`, `note2`, `note3`, `home_hots`, `admin_ranks`, `admin_grade`, `http_in`, `modules`) VALUES (1, 1, 1, 0, 0, 0, 'other', '', 1, '', 'admin', '21232f297a57a5a743894a0e4a801fc3', '2011-06-18 00:00:00', '', '', 0, '', '', '', '', '', '', '', '', 'admin', '0', 'tκ޲zH', '', '', '', '', '', '', '', '', '2011-06-18', 'websit@eduweb.com.tw', '', 0, '1', 0, '1', 1, 'open', '');

-- --------------------------------------------------------

-- 
-- ƪ榡G `eduwebsystem_home`
-- 

CREATE TABLE `eduwebsystem_home` (
  `id` int(11) NOT NULL auto_increment,
  `home_image` varchar(250) collate utf8_unicode_ci NOT NULL default '',
  `home_image_v` varchar(250) collate utf8_unicode_ci NOT NULL default '',
  `home_txt` mediumtext collate utf8_unicode_ci NOT NULL,
  `home_no` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `home_lists` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `home_lists_v` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `home_modules` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `user_ids` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------


-- 
-- ƪ榡G `eduwebsystem_groups`
-- 

CREATE TABLE `eduwebsystem_groups` (
  `id` int(11) NOT NULL auto_increment,
  `free_index` varchar(2) collate utf8_unicode_ci NOT NULL default '',
  `free_title` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `free_name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `free_img` varchar(255) collate utf8_unicode_ci NOT NULL,
  `free_used` int(2) NOT NULL,
  `free_text` mediumtext collate utf8_unicode_ci NOT NULL,
  `free_http` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `free_txt` mediumtext collate utf8_unicode_ci NOT NULL,
  `free_http_mode` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `free_lists` int(11) NOT NULL default '0',
  `free_lists_mv` int(11) NOT NULL default '0',
  `free_http_mode_set1` varchar(10) collate utf8_unicode_ci NOT NULL default '',
  `free_http_mode_set2` varchar(10) collate utf8_unicode_ci NOT NULL default '',
  `free_http_mode_set3` varchar(10) collate utf8_unicode_ci NOT NULL default '',
  `modules_open` int(11) NOT NULL default '0',
  `modules_encryption` int(11) NOT NULL default '0',
  `modules_lr` varchar(3) collate utf8_unicode_ci NOT NULL default '',
  `user_ids` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_ids` int(11) NOT NULL default '0',
  `free_ids` int(11) NOT NULL default '0',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`),
  KEY `modules_ids` (`modules_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- 
-- CXHUƮwƾڡG `eduwebsystem_groups`
-- 


-- 
-- ƪ榡G `eduwebsystem_tool_movemsg`
-- 

CREATE TABLE `eduwebsystem_tool_movemsg` (
  `id` int(11) NOT NULL auto_increment,
  `movemsg_char_setup` varchar(5) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_open` varchar(5) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_date` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_date1` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_http` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_set` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `movemsg_char_set_list` mediumtext collate utf8_unicode_ci NOT NULL,
  `movemsg_txt_01` mediumtext collate utf8_unicode_ci NOT NULL,
  `movemsg_date_01` date NOT NULL default '0000-00-00',
  `movemsg_date_02` datetime NOT NULL default '0000-00-00 00:00:00',
  `movemsg_int_01` int(11) NOT NULL default '0',
  `user_ids` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- 
-- ƪ榡G `eduwebsystem_modules`
-- 

CREATE TABLE `eduwebsystem_modules` (
  `id` int(11) NOT NULL auto_increment,
  `modules_setup` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_names` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_more` varchar(12) collate utf8_unicode_ci NOT NULL default '',
  `modules_datetimes` datetime NOT NULL default '0000-00-00 00:00:00',
  `modules_dates` date NOT NULL default '0000-00-00',
  `modules_lr` varchar(3) collate utf8_unicode_ci NOT NULL default '',
  `db1` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- ƪ榡G `eduwebsystem_mydb`
-- 

CREATE TABLE `eduwebsystem_mydb` (
  `id` int(11) NOT NULL auto_increment,
  `mysql_dbs` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- 
-- ƪ榡G `eduwebsystem_skin`
-- 

CREATE TABLE `eduwebsystem_skin` (
  `id` int(11) NOT NULL auto_increment,
  `admin_https` mediumtext collate utf8_unicode_ci NOT NULL,
  `user_ids` varchar(30) collate utf8_unicode_ci NOT NULL default '0',
  `views` varchar(30) collate utf8_unicode_ci NOT NULL default '0',
  `skin_brk_ids` int(11) NOT NULL default '0',
  `set_1` varchar(50) collate utf8_unicode_ci NOT NULL default 'system:default.jpg',
  `set_2` varchar(50) collate utf8_unicode_ci NOT NULL default 'default',
  `set_3` varchar(50) collate utf8_unicode_ci NOT NULL default 'web title',
  `set_4` varchar(50) collate utf8_unicode_ci NOT NULL default 'none',
  `set_5` varchar(50) collate utf8_unicode_ci NOT NULL default '~ Welcome ~',
  `set_6` varchar(50) collate utf8_unicode_ci NOT NULL default 'none',
  `set_7` varchar(50) collate utf8_unicode_ci NOT NULL default 'system:default.jpg',
  `set_8` varchar(5) collate utf8_unicode_ci NOT NULL default '1',
  `set_9` varchar(5) collate utf8_unicode_ci NOT NULL default '1',
  `set_10` varchar(5) collate utf8_unicode_ci NOT NULL default '0',
  `set_11` varchar(5) collate utf8_unicode_ci NOT NULL default '0',
  `set_12` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `set_13` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `set_14` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `set_15` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `set_16` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

-- 
-- ƪ榡G `eduwebsystem_skin_brk`
-- 

CREATE TABLE `eduwebsystem_skin_brk` (
  `id` int(11) NOT NULL auto_increment,
  `save_name` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `admin_https` mediumtext collate utf8_unicode_ci NOT NULL,
  `user_ids` varchar(30) collate utf8_unicode_ci NOT NULL default '0',
  `views` varchar(30) collate utf8_unicode_ci NOT NULL default '0',
  `set_1` varchar(50) collate utf8_unicode_ci NOT NULL default 'system:default.jpg',
  `set_2` varchar(50) collate utf8_unicode_ci NOT NULL default 'default',
  `set_3` varchar(50) collate utf8_unicode_ci NOT NULL default 'web title',
  `set_4` varchar(50) collate utf8_unicode_ci NOT NULL default 'none',
  `set_5` varchar(50) collate utf8_unicode_ci NOT NULL default '~ Welcome ~',
  `set_6` varchar(50) collate utf8_unicode_ci NOT NULL default 'none',
  `set_7` varchar(50) collate utf8_unicode_ci NOT NULL default 'system:default.jpg',
  `set_8` varchar(5) collate utf8_unicode_ci NOT NULL default '1',
  `set_9` varchar(5) collate utf8_unicode_ci NOT NULL default '1',
  `set_10` varchar(5) collate utf8_unicode_ci NOT NULL default '0',
  `set_11` varchar(5) collate utf8_unicode_ci NOT NULL default '0',
  `set_12` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `set_13` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `set_14` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `set_15` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  `set_16` varchar(11) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


-- 
-- ƪ榡G `eduwebsystem_web_modules`
-- 

CREATE TABLE `eduwebsystem_web_modules` (
  `id` int(11) NOT NULL auto_increment,
  `user_ids` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_setup` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `modules_open` varchar(3) collate utf8_unicode_ci NOT NULL default '0',
  `modules_mv` int(11) NOT NULL default '1',
  `modules_encryption` int(11) NOT NULL default '0',
  `modules_class` varchar(3) collate utf8_unicode_ci NOT NULL default '0',
  `modules_user_class` mediumtext collate utf8_unicode_ci NOT NULL,
  `modules_lr` varchar(3) collate utf8_unicode_ci NOT NULL default 'l',
  KEY `id` (`id`),
  KEY `user_ids` (`user_ids`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- 
-- ƪ榡G `eduwebsystem_log`
-- 

CREATE TABLE `eduwebsystem_log` (
  `id` int(11) NOT NULL auto_increment,
  `ip` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `names` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `user_id` int(11) NOT NULL default '0',
  `logs` varchar(12) collate utf8_unicode_ci NOT NULL default '',
  `modles_log` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `date_log` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_ids` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- 
-- ƪ榡G `eduwebsystem_user_class`
-- 

CREATE TABLE `eduwebsystem_user_class` (
  `id` int(11) NOT NULL auto_increment,
  `class_title` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `class_list` int(11) NOT NULL default '0',
  `class_image` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `user_ids` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;